#!/bin/sh
# first shot at setting up LTSP5
# see alsp http://www.freesource.info/wiki/Dokumentacija/LTSP5
#
# currently depends on postinstall.d/06-pxe.sh for tftp/portmap fixes
# 
# Copyleft (c) 2007 Michael Shigorin <mike@altlinux.org>

. install2-init-functions

[ -z "$AUTOINSTALL" ] || exit 0

MOUNTED=

[ "$METHOD" = "cdrom" -a -n "$CDROMDEV" ] && {
	MOUNTED="$destdir/media/cdrom"
	mount -o ro "$CDROMDEV" "$MOUNTED" || MOUNTED=
}

# FIXME: probably ltsp-build-client should be fixed not to interfere 
# with system apt configuration and caches
cp -a $destdir/var/lib/apt/lists/ $destdir/tmp/

# FIXME: when k-m-r1000 gets back, remove this
subst 's,r1000,,' $destdir/etc/ltsp/ltsp-build-client.conf ||:

# FIXME: /image?
subst 's,MIRROR=.*,MIRROR="rpm file:/media/cdrom ALTLinux base disk",' $destdir/etc/ltsp/ltsp-build-client.conf ||:
mkdir -p $destdir/root/.ltsp-log/ ||:
# exec_chroot doesn't suppress stdout *and* resets environment
#exec_chroot ltsp-build-client 2>&1 | tee $destdir/root/.ltsp-log/ltsp-build-client.log
# don't do env *-i*
env PATH="/sbin:/usr/sbin:$PATH" HOME="/root" TMPDIR="/tmp" chroot "$destdir" ltsp-build-client 2>&1 \
| tee $destdir/root/.ltsp-log/ltsp-build-client.log

# FIXME: /dev/console somehow gets lost :-(
# very much likely that something's overly eager with cleanup
# 20071125: seems fixed, but let it stay for some time...
DEVCONSOLE="$destdir/var/lib/ltsp5/i586/dev/console"
[ -c "$DEVCONSOLE" ] || cp -a /dev/console "$DEVCONSOLE"

# configure base services for 192.168.0.1/24 on some interface
# FIXME: LTSP network prefix should become configurable some day...
cp -a "$destdir/etc/ltsp/dhcpd.conf" "$destdir/etc/dhcp" ||:
subst 's/only_from = 127.0.0.1/only_from = 192.168.0.0\/24/' "$destdir/etc/xinetd.conf" ||:
subst 's/-port -1 //' "$destdir/etc/sysconfig/xfs" ||:
subst 's/ -nolisten tcp//' "$destdir/etc/X11/xinit/xserverrc" ||:
# it's also in 06-pxe, but somehow didn't work for me 20071227:
# a single fix to sysconfig helped
subst 's/^PORTMAP_ARGS="-l".*/#&/' "$destdir/etc/sysconfig/portmap" ||:

# KDM pls (TODO: other dms too in case they are?)
sed -ir 's/^Enable=false/Enable=true/' $destdir/etc/X11/kdm/kdmrc ||:

# chkconfig&restart services needed
# tftp is xinetd-based, service has nothing to do there
# NB: also done in 06-pxe.sh
run_chroot chkconfig nfs on ||:
run_chroot chkconfig dm on ||:
run_chroot chkconfig xfs on ||:
run_chroot chkconfig tftp on ||:
run_chroot chkconfig xinetd on ||:
run_chroot chkconfig portmap on ||:

# add localdev support -- we're on hardware not in VE okay?
grep -q ^fuse $destdir/etc/modules || echo fuse >> $destdir/etc/modules
run_chroot control fusermount public ||:

# FIXME: all hardwired, but a lot of stuff needs to be reconfigured either
# (when ltsp network is going to be configurable); so:
# care for resolving in the most crude manner possible
grep -q ^192.168.0.1 $destdir/etc/hosts || echo "192.168.0.1 server server.ltsp" >> $destdir/etc/hosts
grep -q ^192.168.0.250 $destdir/etc/hosts || {
        for i in `seq 20 250`; do
                echo "192.168.0.$i ws$i ws$i.ltsp" >> $destdir/etc/hosts
        done
}
run_chroot update_chrooted conf

# FIXME: workaround for tricky aptwork in ltsp-build-client, part II
rm -f $destdir/var/cache/apt/*.bin ||:
rm -f $destdir/var/cache/apt/gen{src,pkg}list/* ||:
rm -rf $destdir/var/lib/apt/lists/ ||:
mv $destdir/tmp/lists/ $destdir/var/lib/apt ||:

[ -n "$MOUNTED" ] && umount "$MOUNTED"
